---
page_source: https://juspay.io/in/docs/ec-headless/cordova/base-sdk-integration/create-order-api
page_title: Create Order API
---

## API Version: default


# Create Order API  



This is a Server-to-Server API that takes order parameters as an input and creates an order in the Juspay system and fetches the corresponding client_auth_token. 


---


Amount and order id are the mandatory fields, the contact details like email, phone number, customer id's are conditional and depends on the underlying payment gateway/ aggregator used.  

'UDF' is used to pass any additional information that is required to be stored at Juspay for any analysis or other operations. In some cases, these UDFs are passed to the downstream gateways as well. 

Juspay supports 10 UDFs (UDF1 to UDF10). The values passed in UDFs are reflected back in the order status response and in webhooks back to the merchant. If there are any special characters that need to be passed in UDF values, please use UDF 6 to 10 for passing the same. UDF 1 to 5 can be used to pass values which do not have any special characters.

‘Metadata’ is used to send custom params to the payment aggregators, irrespective of default parameters.

Note: Auth api key should be Base64 encoded.


| Payment Gateways | Fields |
|---|---|
| CCAVENUE_V2 | metadata.CCAVENUE_V2:promo_code |
| BILLDESK | metadata.BILLDESK:AdditionalInfo3 |
| BILLDESK | metadata.BILLDESK:AdditionalInfo4 |
| FREECHARGE | metadata.FREECHARGE:campaignCode |
| GOCASHFREE | metadata.CASHFREE:metadata1 |
| HSBC_UPI | metadata.HSBC_UPI:addInfo |
| MIGS | metadata.MIGS:vpc_AddendumData |
| MIGS | metadata.MIGS:vpc_OrderInfo |
| OLAMONEY | metadata.OLAMONEY:couponCode |
| PAYTM | metadata.PAYTM:PROMO_CAMP_ID |
| PAYTM | metadata.PAYTM:CUST_ID |
| PAYTM | metadata.PAYTM:MERC_UNQ_REF |
| PAYTM_V2 | metadata.PAYTM_V2:MERC_UNQ_REF |
| PAYTM_V2 | metadata.PAYTM_V2:CUST_ID |
| TATAPAY | metadata.TATAPAY: merchantTxnMetadata |
| PAYU | metadata.PAYU:offer_key |
| PAYU | metadata.PAYU:offer_auto_apply |
| PAYU | metadata.PAYU:udf1 |
| PAYU | metadata.PAYU:udf2 |
| PAYU | metadata.PAYU:udf3 |
| PAYU | metadata.PAYU:udf4 |
| PAYU | metadata.PAYU:udf5 |
| PHONEPE | metadata.PHONEPE:merchantContext |
| RAZORPAY | metadata.RAZORPAY:notes[cust_id] |
| RAZORPAY | metadata.RAZORPAY:notes[cust_name] |
| RAZORPAY | metadata.RAZORPAY:offer_id |
| RAZORPAY | metadata.razorpay:PNR |
| RAZORPAY | metadata.razorpay:PaymentID |
| RAZORPAY | metadata.razorpay:lob |
| RAZORPAY | metadata.RAZORPAY:notes <br> Ex: metadata.RAZORPAY:notes={"key1":"value1","key2":"value2","key3":"value3"} |
| Subvention Amount | metadata.subvention_amount |
| TPSL | metadata.TPSL:shoppingCartDetails |
| TPSL | metadata.TPSL:accountNo |
| ZAAKPAY | metadata.ZAAKPAY:productDescription |
| ZAAKPAY | metadata.ZAAKPAY:product1Description |
| PAYPAL | metadata.PAYPAL:landing_page |
| PAYPAL | metadata.PAYPAL:phone_number |
| PAYPAL | metadata.PAYPAL:country_code |
| PAYPAL | metadata.PAYPAL:first_name  |
| PAYPAL | metadata.PAYPAL:last_name  |
| PAYPAL | metadata.PAYPAL:experience_id |
| PAYPAL | metadata.PAYPAL:brand_name |
| PAYPAL | metadata.PAYPAL:additional_data |
| PAYPAL - For Link and Pay  | metadata.PAYPAL:lnp_product_name |
| PAYPAL - For Link and Pay  | metadata.PAYPAL:lnp_product_code |
| PAYPAL - For Link and Pay  | metadata.PAYPAL:lnp_charge_pattern |
| PAYPAL - For Link and Pay  | metadata.PAYPAL:direct_wallet_version |
| PAYPAL - For Link and Pay  | metadata.PAYPAL:purchase_category |
| AMAZONPAY | metadata.AMAZONPAY:sellerNote |
| Digio - for mandate registration | metadata.DIGIO:schemeReference |


> **Note**
> 



**Payment Links** Order create response now has payment links for web, mobile & iFrame. These links can directly be emailed or messaged to your customers. If you wish to use your own branding, then you can embed the iframe link into your page. Note that, these links are not valid perpetually. As soon as your order expires (this can be changed via [our dashboard](https://analytics.expresscheckout.juspay.in/?navtab=euler_settings), the link will cease to work.## Endpoints:
- Sandbox: https://sandbox.juspay.in/orders

- Production: https://api.juspay.in/orders

## Request Type: 
POST

## Content-Type: 
application/json

## Authorization:

#### Basic Auth:
Consists of two parts.

* Username: API Key obtained from Juspay dashboard
* Password: Empty string
- Value: <p>Example:- <br> Basic MUQ2QUxxxxxxxxxxxxU5QTIxQzNFNTQwNkFDMEZCOg==</p>
- Tags: Base64 Encoded username:password, required
## Headers:

#### x-merchantid:
Merchant ID provided by Juspay
- Value: <p>Example:- <br>merchant-id</p>
- Tags: string, required

#### Content-Type:
application/x-www-form-urlencoded
- Tags: String

#### x-routing-id:
We recommend passing the customer_id as the x-routing-id. If the customer is checking out as a guest, you can pass an alternative ID that helps track the payment session lifecycle. For example, this could be an Order ID or Cart ID.

> **Warning**
> This ID is associated with the customer. It plays a key role in ensuring consistency and maintaining connections across different systems. If you fail to pass the same x-routing-id for the same customer in all related API calls, it could lead to issues with API functionality. Therefore, it’s crucial that you use the same x-routing-id for all requests tied to the same customer.


- Value: customer_1122
- Tags: String, Required
## Sample Code Snippets:
### Sample Request:

#### Request Code Snippet:

```request
curl --location --request POST 'https://api.juspay.in/orders' \
--header 'Content-Type: application/x-www-form-urlencoded' \
--header 'x-merchantid: merchant_id'\
--header 'x-routing-id: customer_1122'\
--header 'Authorization: Basic QTA0QT*******ODg1Og==' \
--data-urlencode 'order_id=14183944763' \
--data-urlencode 'amount=100.00' \
--data-urlencode 'currency=INR' \
--data-urlencode 'customer_id=guest_user_101' \
--data-urlencode 'customer_email=customer@gmail.com' \
--data-urlencode 'customer_phone=9988665522' \
--data-urlencode 'product_id=prod-141833' \
--data-urlencode 'return_url=http://shop.merchant.com/payments/handleResponse' \
--data-urlencode 'description=Sample description' \
--data-urlencode 'billing_address_first_name=Juspay' \
--data-urlencode 'billing_address_last_name=Technologies' \
--data-urlencode 'billing_address_line1=Girija Building' \
--data-urlencode 'billing_address_line2=Ganapathi Temple Road' \
--data-urlencode 'billing_address_line3=8th Block, Koramangala' \
--data-urlencode 'billing_address_city=Bengaluru' \
--data-urlencode 'billing_address_state=Karnataka' \
--data-urlencode 'billing_address_country=India' \
--data-urlencode 'billing_address_postal_code=560095' \
--data-urlencode 'billing_address_phone=9988775566' \
--data-urlencode 'billing_address_country_code_iso=IND' \
--data-urlencode 'shipping_address_first_name=Juspay' \
--data-urlencode 'shipping_address_last_name=Technologies' \
--data-urlencode 'shipping_address_line1=Girija Building' \
--data-urlencode 'shipping_address_line2=Ganapathi Temple Road' \
--data-urlencode 'shipping_address_line3=8th Block, Koramangala' \
--data-urlencode 'shipping_address_city=Bengaluru' \
--data-urlencode 'shipping_address_state=Karnataka' \
--data-urlencode 'shipping_address_postal_code=560095' \
--data-urlencode 'shipping_address_phone=9962881912' \
--data-urlencode 'shipping_address_country_code_iso=IND' \
--data-urlencode 'shipping_address_country=India' \
--data-urlencode 'metadata.PAYTM:PROMO_CAMP_ID=xyz' \
--data-urlencode 'metadata.PAYTM:CUST_ID=1234' \
--data-urlencode 'metadata.PAYU:offer_key=1234' \
--data-urlencode 'metadata.PAYU:gateway_reference_id=bus' \
--data-urlencode 'options.get_client_auth_token=true' \
--data-urlencode 'metadata.subvention_amount=90' \
--data-urlencode 'mutual_fund_details=[{"memberId": "ABCDE","userId": "ABCDEFGHIJ","mfPartner": "BSE","folioNumber": "190983010","orderNumber": "order_zer12345","amount": "5000.00","schemeCode": "LT","amcCode": "UYTIUI","panNumber": "TYLIO7823U","investmentType": "LUMPSUM"},{"memberId": "ERTYU","userId": "VTYUIOPFT","mfPartner": "BSE","folioNumber": "190983011","orderNumber": "order_zer12346","amount": "5000.00","schemeCode": "LT","amcCode": "UYTIFT","panNumber": "TYLIO7823U","investmentType": "LUMPSUM"}]'

```

### Sample Response:

#### Response with auth token:
```plaintext
{
  "udf9": "",
  "udf8": "",
  "udf7": "",
  "udf6": "",
  "udf5": "",
  "udf4": "",
  "udf3": "",
  "udf2": "",
  "udf10": "",
  "udf1": "",
  "status_id": 10,
  "status": "NEW",
  "return_url": "",
  "refunded": false,
  "product_id": "",
  "payment_links": {
    "web": "https://api.juspay.in/merchant/pay/ordeu_8bddad1e3b9c85eab3db4528575c01b",
    "mobile": "https://api.juspay.in/merchant/pay/ordeu_8bddad1e3b9c85eab3db4528575c01b?mobile=true",
    "iframe": "https://api.juspay.in/merchant/ipay/ordeu_8bddad1e3b9c485eab3db4528575c01b"
  },
  "order_id": "14183944763",
  "merchant_id": "merchantId",
  "juspay": {
    "client_auth_token_expiry": "2020-06-16T10:43:35Z",
    "client_auth_token": "tkn_753275c49a44a1a313eb2567f2fd6b"
  },
  "id": "ordeu_8bddad1e3b9c85eab3db4528575c01b",
  "date_created": "2020-06-16T10:28:35Z",
  "customer_phone": "9999999999",
  "customer_id": "1235677",
  "customer_email": "test@gmail.com",
  "currency": "INR",
  "amount_refunded": 0,
  "amount": 1
}
```

#### Response without auth token:
```json
{
  "status": "CREATED",
  "status_id": 1,
  "id": "ord_e294a26e66ad4336a992ceab81ad704c",
  "order_id": "14183944763",
  "payment_links": {
    "web": "https://api.juspay.in/merchant/pay/ord_e294a26e66ad4336a992ceab81ad704c",
    "mobile": "https://api.juspay.in/merchant/pay/ord_e294a26e66ad4336a992ceab81ad704c?mobile=true",
    "iframe": "https://api.juspay.in/merchant/ipay/ord_e294a26e66ad4336a992ceab81ad704c"
  }
}
```

## Body Parameters:
### Basic Parameters:

#### order_id:
- Description: Unique Identifier for the order. Should be Alphanumeric with character length less than 21.
- Value: <p>Example:- <br> orderid9876580 </p>
- Tags: string, required

#### amount:
- Description: Amount that the customer has to pay. Will accept stringified double or integer values with upto two decimal places. For example, "100.15" and "100" are valid input but "100.1532" is not valid.
- Value: <p>Example:- <br> 1.00 </p>
- Tags: Double, required

#### options.get_client_auth_token:
- Description: Client side authentication token required for Hyper SDK calls.Token expiry time is 15 minutes. 
- Value: Value : true
- Tags: string

#### customer_id:
- Description: It is the ID with which merchant refers to a customer object. This id is used to access the stored payment methods, allow EMI transactions and setup subscriptions. 

In case of guest login it should be an empty string.
- Value: <p>Example:- <br> customer-id-007 </p>
- Tags: string, Required

#### customer_email:
- Description: Email address of the customer. If the backend gateway requires it, then you must send this value.
- Value: <p>Example:- <br> test@gmail.com</p>
- Tags: string

#### customer_phone:
- Description: Mobile number or fixed line number of the customer. If the backend gateway requires it, then you must send this value.
- Value: <p>Example:- <br> 9999999912</p>
- Tags: string

#### currency:
- Description: ISO string of the currency. Use INR for Indian Rupee. Among other accepted values are EUR, USD, GBP. Default value: INR
- Tags: string

#### description:
- Description: Short description for the order. We send this information to the backend gateways whenever there is a provision for this.
- Tags: string

#### return_url:
- Description: A fully qualified URL which the customer will be redirected after payment completion. It is also required to provide the control back to SDK after the completion of transaction. This URL shouldn't contain any query parameters or Ip address. This URL takes higher precedence over the common return URL configured in your account settings.
- Value: <p>Example:- <br> https://shop.merchant.com </p>
- Tags: string

#### product_id:
- Description: An identifier for the product. Fits well for impulse purchase usecases.
- Value: <p>Example:- <br> John </p>
- Tags: string

#### gateway_id:
- Description: Specify your preferred gateway for this order. Refer to mapping [here](https://docs.juspay.in/resources/docs/dynamic-routing/dynamic-routing#enumerations-and-gateway-ids).
- Value: <p>Example:- <br> 15 </p>
- Tags: Number, Tag

#### billing_address_first_name:
- Description: First name in the billing address
- Tags: string

#### billing_address_last_name:
- Description: Last name in the billing address
- Tags: string

#### billing_address_line1:
- Description: Line1 in the billing address
- Tags: string

#### billing_address_line2:
- Description: Line2 in the billing address
- Tags: string

#### billing_address_line3:
- Description: Line3 in the billing address
- Tags: string

#### billing_address_city:
- Description: Billing address city
- Tags: string

#### billing_address_state:
- Description: Billing address state
- Tags: string

#### billing_address_country:
- Description: Billing address country
- Tags: string

#### billing_address_postal_code:
- Description: Billing address postal code or zip code
- Tags: string

#### billing_address_phone:
- Description: Mobile or phone number in the billing address
- Tags: string

#### billing_address_country_code_iso:
- Description: ISO Country code Default value: IND
- Tags: string

#### shipping_address_first_name:
- Description: First name in the shipping address
- Tags: string

#### shipping_address_last_name:
- Description: Last name in the shipping address
- Tags: string

#### shipping_address_line1:
- Description: Line1 in the shipping address
- Tags: string

#### shipping_address_line2:
- Description: Line2 in the shipping address
- Tags: string

#### shipping_address_line3:
- Description: Line3 in the shipping address
- Tags: string

#### shipping_address_city:
- Description: Shipping address city
- Tags: string

#### shipping_address_state:
- Description: Shipping address state
- Tags: string

#### shipping_address_country:
- Description: Shipping address country
- Tags: string

#### shipping_address_postal_code:
- Description: Shipping address postal code or zip code
- Tags: string

#### shipping_address_phone:
- Description: Mobile or phone number in the shipping address
- Tags: string

#### shipping_address_country_code_iso:
- Description: ISO Country code Default value: IND
- Tags: string

#### order_type:
- Description: **TPV_PAYMENT** . Applicable only for TPV Orders.
- Tags: String, Conditional
### Metadata Object:

#### metadata.JUSPAY:gateway_reference_id:
- Description: **Use this parameter only when you have use case of gateway reference ID.** For detailed information check [here](https://docs.juspay.in/resources/docs/common-resources/gateway-reference-id).
- Value: <p>Example:- <br> BUS </p>
- Tags: string, Optional

#### metadata.subvention_amount:
- Description: The amount for which the EMI interest should not be calculated. Ex: **metadata.subvention_amount=90** 
- Tags: String, Optional

#### metadata.webhook_url:
- Description: Merchant can pass dynamic webhook URL in this field. The webhook authentication would be same as the one configured on the dashboard. Ex: **metadata.webhook_url=** **[https://merchant.juspay/response](https://merchant.juspay/response)** 
- Tags: String, Optional

#### metadata.bank_account_details:
- Description: Applicable for TPV Orders.

Either bank_account_number or bank_account_id is mandatory
- Value:
  - **Bank_account_number**:
    - Description: Customer Bank account
    - Tags: String, Conditional
  - **Bank_ifsc**:
    - Description: IFSC code of bank
    - Tags: String, Optional
  - **Juspay_bank_code**:
    - Description: juspay bank code given in eligibility API. e.g. JP_HDFC
    - Tags: String, Optional
  - **Bank_beneficiary_name**:
    - Description: Name of account holder
    - Tags: String, Optional
  - **Bank_account_id**:
    - Description: bank account id provided by Juspay while storing bank account details
    - Tags: String, Conditional
  - **Bank_account_type**:
    - Description: Account type of the Customer Account
    - Value: CURRENT or SAVINGS
    - Tags: String, Conditional
- Tags: Array, Conditional
### User Defined Parameters (UDF):

#### udf1 , udf2 , udf3 , udf4, udf5:
- Description: User Defined Parameter (UDF)

This field can be used to send any user defined parameters

The UDF parameters for orders can be seen in the JUSPAY dashboard under each order
- Value: <p>Example:- <br>user5349</p>
- Tags: string (Upto 255 characters), No special characters supported

#### udf6 , udf7 , udf8 , udf9 , udf10:
- Description: User Defined Parameter (UDF)

This field can be used to send any user defined parameters

The UDF parameters for orders can be seen in the JUSPAY dashboard under each order
- Value: <p>Example:-<br>user_5349</p>
- Tags: string (Upto 255 characters), Special characters supported
### Mutual Fund Details:

#### mutual_fund_details:
- Description: Contains the details of Mutual Fund.
- Value:
  - **MemberId**:
    - Description: Member Id with ICCL or ARN_RIA with RTA.
    - Tags: String, Mandatory
  - **UserId**:
    - Description: Client Id with ICCL or USER_CODE with RTA.
    - Tags: String, Mandatory
  - **MfPartner**:
    - Description: NSE/BSE/KFIN/CAMS.
    - Tags: String, Mandatory
  - **OrderNumber**:
    - Description: Unique order number of each MF. Oder Number in ICCL or APPL_NO in RTA.
    - Tags: String, Mandatory
  - **Amount**:
    - Description: Individual MF amount within the array of MF being purchased.
    - Tags: String, Mandatory
  - **InvestmentType**:
    - Description: LUMPSU/ SIP
    - Tags: String, Mandatory
  - **FolioNumber**:
    - Description: Folio Number of the MF, used for RTA reporting. Mandatory for RTA reporting.
    - Tags: String, Optional
  - **PanNumber**:
    - Description: PAN Number of the user, used for RTA reporting. Mandatory for RTA reporting.
    - Tags: String, Optional
  - **AmcCode**:
    - Description: AMC Code of the MF, used for RTA reporting. Mandatory for RTA reporting.
    - Tags: String, Optional
  - **SchemeCode**:
    - Description: Scheme Code of the MF, used for RTA reporting. Mandatory for RTA reporting.
    - Tags: String, Optional
  - **IhNumber**:
    - Description: In-house Number of the SIP (Mandatory for K-Fin RTA)
    - Tags: String, Conditional
- Tags: List, Optional
### Cross Border Details:

#### cross_border_details:
- Description: If the requirement is to send details across cross border, then these details need to be sent, it can change based on PG to PG , so please confirm with them , what is mandatory for them for this requirement. 
- Value:
  - **Invoice_number**:
    - Description: Invoice number required for transaction.
    - Tags: String, Mandatory
  - **Goods_description**:
    - Description: Description of goods
    - Value: Tubelight
    - Tags: String, Optional
  - **Shipping_addreess**:
    - Description: Shipping address of customer
    - Value:
      - **Line1**:
        - Value: Mantri apartment
        - Tags: String, Mandatory
      - **Line2**:
        - Value: Koramangala
        - Tags: String, Mandatory
      - **City**:
        - Value: Bangaluru
        - Tags: String, Mandatory
      - **Country**:
        - Tags: String, Mandatory
      - **State_name**:
        - Value: Karnataka
        - Tags: String, Mandatory
      - **Zipcode**:
        - Value: 560032
        - Tags: String, Mandatory
      - **Latitude**:
        - Value: 123123
        - Tags: String, Optional
      - **Longitude**:
        - Value: 1231231
        - Tags: String, Optional
      - **Country_iso**:
        - Tags: String, Optional
    - Tags: String, Optional
  - **Customer_info**:
    - Value:
      - **Customer_name**:
        - Value: ABCDEFGHIJ
        - Tags: String, Mandatory
      - **Customer_email**:
        - Value: test@test.com
        - Tags: String, Optional
      - **Customer_reference_id**:
        - Description: A specific customer reference number based on Id created at merchant’s end
        - Value: cust_zer12345ssss
        - Tags: String, Optional
      - **Customer_national_id**:
        - Value: ABCDE123
        - Tags: String, Optional
      - **Customer_dob**:
        - Description: DD/MM/YYYY format
        - Value: 06/08/1995
        - Tags: String, Optional
      - **Customer_pan_number**:
        - Description: Required for amount > 2.5 Lakhs
        - Tags: String, Conditional
      - **Customer_account_debit_reference**:
        - Value: LUMPSUM
        - Tags: String, Optional
      - **Customer_mobile_number**:
        - Value: 9988776655
        - Tags: String, Optional
    - Tags: String, Optional
  - **Seller_info**:
    - Value:
      - **Seller_name**:
        - Tags: String, Optional
      - **Seller_bank_account_number**:
        - Tags: String, Optional
      - **Seller_registered_address**:
        - Tags: String, Optional
    - Tags: String, Optional
  - **Billing_address**:
    - Value:
      - **Line1**:
        - Tags: String, Optional
      - **Line2**:
        - Tags: String, Optional
      - **City**:
        - Tags: String, Optional
      - **Country**:
        - Tags: String, Optional
      - **State_name**:
        - Tags: String, Optional
      - **Zipcode**:
        - Tags: String, Optional
      - **Latitude**:
        - Tags: String, Optional
      - **Longitude**:
        - Tags: String, Optional
      - **Country_iso**:
        - Tags: String, Optional
    - Tags: String, Optional
- Tags: String, Optional
### Payment Rule:

#### payment_rules:
- Value:
  - **Payment_flows**:
    - Value:
      - **Reverse_penny_drop**:
        - Value:
          - **Status**:
            - Value: DISABLED - Juspay will ignore the parameter| REQUIRED - Juspay will consider the parameter | OPTIONAL - Juspay will ignore the parameter
            - Tags: String, Optional
        - Tags: Object, Optional
    - Tags: Object, Mandatory
- Tags: Object, Optional
## API Responses:
### 200:

#### status:
- Description: Status of order Example:- NEW
- Tags: string

#### status_id:
- Description: Status ID is a numeric id corresponding to the status value.
- Tags: integer

#### id:
- Description: Unique ID generated by Juspay for the given order
- Tags: string

#### order_id:
- Description: Order Id passed during order creation
- Tags: string

#### payment_links:
- Description: Https link using which user can open payment page and perform transaction against the order created
- Value:
  - **Web**:
    - Tags: string
  - **Mobile**:
    - Tags: string
  - **Iframe**:
    - Tags: string
- Tags: JSON

#### juspay:
- Value:
  - **Client_auth_token_expiry**:
    - Tags: string
  - **Client_auth_token**:
    - Tags: string
- Tags: JSON
### 400:

#### status:
- Description: Bad Request
- Tags: string

#### error_code:
- Description: Details of keys missing
- Value: <p>Example:- <br> Mandatory fields are missing </p>
- Tags: string

#### error_message:
- Description: Further Details of keys missing
- Tags: string



### API Latency Guidelines




#### **What is API Latency?** 



Time taken by the server to respond to the API request.


#### **Average API Percentile Metrics and Recommended Timeout** 



**TP50 (ms)** : This represents the median latency, meaning 50% of all requests are completed in this time or less. It indicates the typical performance experienced by the majority of users.

**TP90 (ms)** : This value shows that 90% of requests are completed within this time, leaving 10% of requests that take longer. It gives insight into the performance for a broader set of users, beyond the median.

**TP99 (ms)** : This value indicates that 99% of requests finish within this time, with only 1% of requests taking longer. It helps identify outlier cases where latency may become an issue for a small group of users.

**TP99.9 (ms)** : This metric captures extreme latency outliers, where only 0.1% of requests take longer than this value. It’s useful for understanding edge cases where performance degrades for very few users.

**TP99.99 (ms)** : This measures the most rare and severe performance outliers, where just 0.01% of requests exceed this time. Monitoring this helps in addressing the rarest and most critical latency issues that may impact user experience in exceptional scenarios.


|  Transaction Percentile |  Latency (ms) |
|---|---|
|  TP50 (ms) | 46.14 |
|  TP90 (ms) | 68.42 |
|  TP99 (ms) | 583 |
|  TP99.9 (ms) | 1511.28 |
| Recommended Timeout(ms) | 2000 |


> **Warning**
> The recommended timeouts are based on TP99.9 data, though edge cases (0.01% of requests) may still exceed these limits and are captured in the TP99.99 data as shown below.
> 
> 
> |  Transaction Percentile |  Latency (ms) |
> |---|---|
> |  TP99.99 (ms) | 2398.42 |
> | Recommended Timeout(ms) | 3000 |
> 

